Loading...
Searching...
No Matches
simpleBase.h
Go to the documentation of this file.
// -*- Mode: C++; tab-width: 2: -*-
// vi: set ts=2:
//
//
#ifndef BALL_QSAR_SIMPLEBASE_H
#define BALL_QSAR_SIMPLEBASE_H
#ifndef BALL_QSAR_DESCRIPTOR_H
#include <BALL/QSAR/descriptor.h>
#endif
namespace BALL
{
class BALL_EXPORT SimpleBase
: public Descriptor
{
public:
SimpleBase();
SimpleBase(const SimpleBase& sb);
SimpleBase(const String& name);
SimpleBase(const String& name, const String& unit);
virtual ~SimpleBase();
virtual SimpleBase& operator = (const SimpleBase& sb);
void computeAllDescriptors(AtomContainer& ac);
void setDataFolder(const char* folder);
protected:
/*_ Returns true if the data is calculated already, and the data is still correct,
otherwise false is returned
@param molecule to examine
*/
bool isValid_(AtomContainer& ac);
/*_ Performs the calculation of some of the simple descriptors.
*/
void calculate_(AtomContainer& ac);
private:
/*_ This method calculates the pmi of the x, y and z axis, return the pmi
@param referenced double which holds the pmi x component after calculation
@param referenced double which holds the pmi y component after calculation
@param referenced double which holds the pmi z component after calculation
@param molecule from which the pmi is calculated
*/
double calcPrincipalMomentOfInertia_(double& pmi_x, double& pmi_y, double& pmi_z, AtomContainer& ac);
/*_ Helper function that reads the atomic polarizabilities
from a file from the data section of BALL. It is called from
getAtomicPolarizability_ and reads into a static variable, hence
it is read one time per instance.
*/
void readAtomicPolarizabilities_(std::vector<float>& polarizabilities);
/*_ Method which returns the atomic polarizability of the element given as parameter
@param the atomic number of the element
*/
float getAtomicPolarizability_(int atomic_number);
/*_ Predicate that returns true if the atom is a carbon and in an
exclusively aromatic or aliphatic surrounding, means is only
bound to carbon an hydrogen!
*/
bool isHydrophobic_(const Atom* atom) const;
String data_folder_;
};
} // namespace BALL
#endif
BALL_EXPORT
#define BALL_EXPORT
Definition COMMON/global.h:50
sb
sb
Definition GAFFTypeProcessor.h:72
BALL::AtomContainer
Definition atomContainer.h:32
BALL::Atom
Definition atom.h:90
BALL::Descriptor::Descriptor
Descriptor()
BALL::SimpleBase::SimpleBase
SimpleBase()
BALL::SimpleBase::calculate_
void calculate_(AtomContainer &ac)
BALL::SimpleBase::computeAllDescriptors
void computeAllDescriptors(AtomContainer &ac)
BALL::SimpleBase::~SimpleBase
virtual ~SimpleBase()
BALL::SimpleBase::isValid_
bool isValid_(AtomContainer &ac)
BALL::SimpleBase::SimpleBase
SimpleBase(const String &name, const String &unit)
BALL::SimpleBase::SimpleBase
SimpleBase(const String &name)
BALL::SimpleBase::SimpleBase
SimpleBase(const SimpleBase &sb)
BALL::SimpleBase::setDataFolder
void setDataFolder(const char *folder)
BALL::String
Definition string.h:57
descriptor.h
BALL
Definition constants.h:13